(*  Title:  build the Isac-Kernel: MathEngine & Knowledge
    Author: Walther Neuper, TU Graz, 100808
   (c) due to copyright terms

For creating a heap image of isac see ~~/ROOT.
For debugging see text at begin below, e.g. theory dependencies:
  ~$ evince file:///home/wneuper/.isabelle/isabisac/browser_info/Unsorted/Isac/session_graph.pdf &
                                       
ATTENTION: no errors in this theory do not mean that there are no errors in Isac ..
.. open theories collecting files from folders: BaseDefinitions.thy, ProgLang.thy etc.
Errors are rigorously detected by isabelle build.
*)

theory Build_Isac
imports
(*  theory Know_Store imports Complex_Main
    $ISABELLE_ISAC/BaseDefinitions
      ML_file libraryC.sml
      ML_file theoryC.sml
      ML_file unparseC.sml
      ML_file "rule-def.sml"
      ML_file "thmC-def.sml"
      ML_file "eval-def.sml"
      ML_file "rewrite-order.sml"
      ML_file rule.sml
      ML_file "error-pattern-def.sml"
      ML_file "rule-set.sml"
      
      ML_file "store.sml"
      ML_file "check-unique.sml"
      ML_file "specification.sml"
      ML_file "model-pattern.sml"
      ML_file "problem-def.sml"
      ML_file "method-def.sml"
      ML_file "cas-def.sml"
      ML_file "thy-write.sml"
  theory BaseDefinitions imports Know_Store
  $ISABELLE_ISAC/BaseDefinitions
    ML_file termC.sml
    ML_file substitution.sml
    ML_file contextC.sml
    ML_file environment.sml
( ** )    "BaseDefinitions/BaseDefinitions"( **)
(*
      theory Calc_Binop imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
        at $ISABELLE_ISAC/ProgLang
        ML_file evaluate.sml
      theory ListC imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
      theory Program imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    theory Prog_Expr imports Calc_Binop ListC Program
     theory Prog_Tac imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
      theory Tactical imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    theory Auto_Prog imports Prog_Tac Tactical
  theory ProgLang imports Prog_Expr Auto_Prog
    at $ISABELLE_ISAC/ProgLang
( ** )    "ProgLang/ProgLang"( **)
(*
  theory MathEngBasic imports
    "$ISABELLE_ISAC/ProgLang/ProgLang" "$ISABELLE_ISAC/Specify/Input_Descript"
    at $ISABELLE_ISAC/MathEngBasic
    ML_file thmC.sml
    ML_file "model-def.sml"
    ML_file problem.sml
    ML_file method.sml
    ML_file "cas-command.sml"
  
    ML_file rewrite.sml
  
    ML_file "istate-def.sml"
    ML_file "calc-tree-elem.sml"
    ML_file "pre-conds-def.sml"
  
    ML_file tactic.sml
    ML_file applicable.sml
  
    ML_file position.sml
    ML_file "ctree-basic.sml"
    ML_file "ctree-access.sml"
    ML_file "ctree-navi.sml"
    ML_file ctree.sml
  
    ML_file "state-steps.sml"
    ML_file calculation.sml
( ** )    "MathEngBasic/MathEngBasic"( **)
(*
    theory Input_Descript imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    $ISABELLE_ISAC/Specify
  theory Specify imports "$ISABELLE_ISAC/ProgLang/ProgLang" Input_Descript
  $ISABELLE_ISAC/Specify
    ML_file formalise.sml
    ML_file "o-model.sml"
    ML_file "i-model.sml"
    ML_file "p-model.sml"
    ML_file model.sml
    ML_file "pre-conditions.sml"
    ML_file refine.sml
    ML_file "mstools.sml" (*..TODO review*)
    ML_file ptyps.sml     (*..TODO review*)
    ML_file "test-out.sml"
    ML_file "specify-step.sml"
    ML_file calchead.sml  (*..TODO review*)
    ML_file "input-calchead.sml"
    ML_file "step-specify.sml"
    ML_file specify.sml
( ** )    "Specify/Specify"( **)
(*
  theory Interpret imports "$ISABELLE_ISAC/Specify/Specify"
  $ISABELLE_ISAC/Interpret
    ML_file istate.sml
    ML_file "sub-problem.sml"
    ML_file "thy-read.sml"
    ML_file "li-tool.sml"
    ML_file "solve-step.sml"
    ML_file "error-pattern.sml"
    ML_file derive.sml
    ML_file "lucas-interpreter.sml"
    ML_file "step-solve.sml"
( ** )    "Interpret/Interpret"( **)
(*
  theory MathEngine imports Interpret.Interpret
  $ISABELLE_ISAC/MathEngine
    ML_file "fetch-tactics.sml"
    ML_file solve.sml
    ML_file step.sml
    ML_file "detail-step.sml"
    ML_file "mathengine-stateless.sml"
    ML_file messages.sml
    ML_file states.sml
( ** )    "MathEngine/MathEngine"( **)
(*
  theory Test_Code imports "$ISABELLE_ISAC/MathEngine/MathEngine"
  $ISABELLE_ISAC/Test_Code
    ML_file "test-code.sml"
( ** )    "Test_Code/Test_Code"( **)
(*
  theory BridgeLibisabelle imports "$ISABELLE_ISAC/MathEngine/MathEngine"
  $ISABELLE_ISAC/BridgeLibisabelle
    ML_file "thy-present.sml"
    ML_file mathml.sml   
    ML_file datatypes.sml
    ML_file "pbl-met-hierarchy.sml"
    ML_file "thy-hierarchy.sml" 
    ML_file "interface-xml.sml"
    ML_file interface.sml
( ** )    "BridgeLibisabelle/BridgeLibisabelle"( **)
(*
    theory Calculation imports Calculation (*preliminary for starting Isabelle/Isac*)
    $ISABELLE_ISAC/BridgeJEdit
      ML_file preliminary.sml
  theory BridgeJEdit imports Calculation (*preliminary for starting Isabelle/Isac*)
  $ISABELLE_ISAC/BridgeJEdit
( ** )    "BridgeLibisabelle/BridgeLibisabelle"( **)
(*
        theory E_Collect imports "$ISABELLE_ISAC/Knowledge/Build_Thydata"
      theory Calculation imports E_Collect "$ISABELLE_ISAC/Knowledge/Build_Isac"
        ML_file "user-model.sml"
        (*ML_file "template.sml"*)
        ML_file "preliminary.sml"
    theory VSCode_Example imports Calculation
  theory BridgeJEdit imports VSCode_Example    
( **)    "BridgeJEdit/BridgeJEdit"  (*DEactivate after devel.of BridgeJEdit*)

          "Knowledge/Build_Thydata" (*imports Isac.thy etc*)

(*//-----------------------------------------------------------------------------------------\\*)
(*\\-----------------------------------------------------------------------------------------//*)
begin
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> 
subsection \<open>make Minisubpbl independent from Thy_Info\<close>
text \<open>
  We want Isac to become independent from sessions Specify, Interpret and Isac.
  This goal will be checked by the tests finally.
  As first step we go top down and make Minisubpbl independent form Thy_Info here
  and make sure, that the right ctxt is passed throughout the code.
  As next step we go bottom up from Thy_Info.get_theory and remove it.
  Afterwards $ISABELLE_ISAC_TEST will be changed accordingly.
\<close>
(** ) (* evaluated in Test_Isac/_Short *)
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/000-comments.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/100-init-rootpbl.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/150a-add-given-Maximum.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/150-add-given-Equation.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/200-start-method-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/200-start-method.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/250-Rewrite_Set-from-method-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/250-Rewrite_Set-from-method.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/300-init-subpbl-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/300-init-subpbl.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/400-start-meth-subpbl.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/450-Rewrite_Set_Inst.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/470-Check_elementwise-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/490-nxt-Check_Postcond.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/500-met-sub-to-root.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/530-error-Check_Elementwise.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/600-postcond-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/600-postcond.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/700-interSteps.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/710-interSteps-short.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/790-complete-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/790-complete.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/800-append-on-Frm.sml"
( **)                               
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Specify/i-model.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Specify/pre-conditions.sml"

  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/e-collect.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/user-model.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/template.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/preliminary.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/calculation.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/BridgeJEdit/vscode-example.sml"
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> 

section \<open>check presence of definitions from directories\<close>

(*declare [[ML_print_depth = 999]]*)
ML \<open>Eval.adhoc_thm; (*from "ProgLang/evaluate.sml" *)\<close>
ML \<open>Rewrite.rewrite_; (*from "ProgLang/rewrite.sml" *)\<close>
ML \<open>Input_Descript.for_real_list; (*from "Input_Descript.thy" *)\<close>
ML \<open>(*Test_Code.me;*)\<close>
text \<open>contextthyOK2xml; (*"xmlsrc/interface-xml.sml"*)\<close>
ML \<open>prog_expr\<close>
                                                         
ML \<open>Prog_Expr.eval_occurs_in\<close>
ML \<open>@{thm last_thmI}\<close>
(** )ML \<open>@{thm Querkraft_Belastung}\<close>( *exception FAIL NONE raised (line 161 of "General/scan.ML")*)

declare [[check_unique = false]]
ML \<open>writeln "**** isac kernel = math-engine + Knowledge complete ******"\<close>
ML \<open>@{theory "Isac_Knowledge"}\<close>
ML \<open>(*get_the ["IsacKnowledge", "Diff", "Theorems", "diff_sin_chain"]
  ERROR: app_py: not found: ["IsacKnowledge", "Diff", "Theorems", "diff_sin_chain"]*)\<close>

section \<open>State of approaching Isabelle by Isac\<close>
text \<open>
  Mathias Lehnfeld gives the following list in his thesis in section 
  4.2.3 Relation to Ongoing Isabelle Development.
\<close>
subsection \<open>(0) Survey on remaining Unsynchronized.ref\<close>
text \<open>
  DONE
\<close>
subsection \<open>(1) Exploit parallelism for concurrent session management\<close>
subsection \<open>(2) Make Isac’s programming language usable\<close>
subsection \<open>(3) Adopt Isabelle’s numeral computation for Isac\<close>
text \<open>
  In 2002 isac already strived for floating point numbers. Since that time
  isac represents numerals as "Free", see below (*1*). These experiments are
  unsatisfactory with respect to logical soundness.
  Since Isabelle now has started to care about floating point numbers, it is high 
  time to adopt these together with the other numerals. Isabelle2012/13's numerals
  are different from Isabelle2011, see "$ISABELLE_ISAC_TEST/Tools/isac/ProgLang/termC.sml".
  
  The transition from "Free" to standard numerals is a task to be scheduled for 
  several weeks. The urgency of this task follows from the experience, 
  that (1.2) for "thehier" is very hard, because "num_str" seems to destroy 
  some of the long identifiers of theorems which would tremendously simplify
  building a hierarchy of theorems according to (1.2), see (*2*) below.
\<close>
ML \<open>(*1*) Free ("123.456", HOLogic.realT)\<close>

subsection \<open>(4) Improve the efficiency of Isac’s rewrite-engine\<close>
subsection \<open>(5) Adopt Isabelle/jEdit for Isac\<close>

end
