theory InsSort imports "Interpret.Interpret" Rational(*for norm_Rational?!?*)
begin

section \<open>consts\<close>
consts
  unsorted   :: "int xlist => unl"
  sorted     :: "int xlist => unl"

  (* CAS-command *)
  Sort       :: "int xlist \<Rightarrow> int xlist"

section \<open>functions\<close>
primrec ins :: "int \<Rightarrow> int xlist \<Rightarrow> int xlist"
where
ins_Nil:  "ins i {|| ||} = {||i||}" |
ins_Cons: "ins i (x @# xs) = (if i < x then (i @# x @# xs) else x @# (ins i xs))"

consts sort :: "int xlist \<Rightarrow> int xlist"
axiomatization where
sort_deff [code]: "sort xs = xfoldr ins xs {|| ||}"
(* this broke with 406681ebe781 ERROR "partial_function: shift respective thys to ProgLang" with
   ERROR Tactic failed
   The error(s) above occurred for the goal statement\<^here>:
   sort xs = xfoldr ins xs {|| ||}
fun sort :: "int xlist \<Rightarrow> int xlist"
where
sort_deff: "sort xs = xfoldr ins xs {|| ||}"
*)
print_theorems
(* thm sort_def  InsSort.sort \<equiv> sort_sumC *)
thm sort_deff (* InsSort.sort ?xs = foldr ins ?xs [] *)

(* access to definitions from ML *)
ML \<open>
@{thm ins.simps(1)};
@{thm ins.simps(2)};
\<close>

value "sort {||2,3,1||}"
(* this broke with 406681ebe781 ERROR "Failed to apply initial proof method\<^here>:" with
lemma test: "sort {||2,3,1||} = {||1,2,3||}"
by auto
*)

section \<open>eval functions\<close>
section \<open>term order\<close>
section \<open>rulesets\<close>
ML \<open>
val ins_sort = 
  Rule_Def.Repeat {
    id = "ins_sort", preconds = [], rew_ord = ("tless_true", tless_true), asm_rls = Rule_Set.empty,
    prog_rls = Rule_Set.empty, calc = [], rules = [
      \<^rule_thm>\<open>xfoldr_Nil\<close> (*num_str*) (* foldr ?f [] = id *),
	    \<^rule_thm>\<open>xfoldr_Cons\<close> (* foldr ?f (?x # ?xs) = ?f ?x \<circ> foldr ?f ?xs *),

	    \<^rule_thm>\<open>ins_Nil\<close> (* ins ?i [] = [?i] *),
	    \<^rule_thm>\<open>ins_Cons\<close> (* ins ?i (?x # ?xs) = (if ?i < ?x then ?i # ?x # ?xs else ?x # ins ?i ?xs) *),
	    \<^rule_thm>\<open>sort_deff\<close> (* InsSort.sort ?xs = foldr ins ?xs [] *),

	    \<^rule_thm>\<open>o_id\<close> (* ?f \<circ> id = ?f *),
	    \<^rule_thm>\<open>o_assoc\<close> (* ?f \<circ> (?g \<circ> ?h) = ?f \<circ> ?g \<circ> ?h *),
	    \<^rule_thm>\<open>o_apply\<close> (* (?f \<circ> ?g) ?x = ?f (?g ?x) *),
	    \<^rule_thm>\<open>id_apply\<close> (* id ?x = ?x *),

	    \<^rule_eval>\<open>less\<close> (Prog_Expr.eval_equ "#less_"),
	    \<^rule_thm>\<open>If_def\<close> (* if ?P then ?x else ?y \<equiv> THE z. (?P = True \<longrightarrow> z = ?x) \<and> (?P = False \<longrightarrow> z = ?y) *),
	    \<^rule_thm>\<open>if_True\<close> (* "(if True then x else y) = x" *),
	    \<^rule_thm>\<open>if_False\<close> (* "(if False then x else y) = y" *)],
	  errpatts = [], program = Rule.Empty_Prog};      
\<close>
rule_set_knowledge ins_sort = ins_sort

section \<open>problems\<close>

problem pbl_Programming : Programming = \<open>Rule_Set.empty\<close>

problem pbl_Prog_sort : "SORT/Programming" = \<open>Rule_Set.empty\<close>

problem pbl_Prog_sort_ins : "insertion/SORT/Programming" =
  \<open>Rule_Set.empty\<close>
  Method_Ref: "Programming/SORT/insertion_steps"
  CAS: "Sort u_u"
  Given: "unsorted u_u"
  Find: "sorted s_s"

section \<open>methods\<close>
(* TODO: implementation needs extra object-level lists ?!?*)

method met_Programming : "Programming" =
  \<open>{rew_ord="tless_true",rls' = Rule_Set.empty, calc = [], prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
    errpats = [], rew_rls = Rule_Set.empty}\<close>

method met_Prog_sort : "Programming/SORT" =
  \<open>{rew_ord="tless_true",rls' = Rule_Set.empty, calc = [], prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
    errpats = [], rew_rls = Rule_Set.empty}\<close>

partial_function (tailrec) sort_program :: "int xlist => int xlist"
  where
"sort_program unso = (
  let
    uns = Take (sort unso)
  in
    (Rewrite_Set ''ins_sort'') uns)"

method met_Prog_sort_ins : "Programming/SORT/insertion" =
  \<open>{rew_ord="tless_true",rls' = Atools_erls, calc = [], prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
    errpats = [], rew_rls = norm_Rational}\<close>
  Program: sort_program.simps
  Given: "unsorted u_u"
  Find: "sorted s_s"

partial_function (tailrec) sort_program2 :: "int xlist => int xlist"
  where 
"sort_program2 unso = (
  let
    uns = Take (sort unso) 
  in (
    Repeat (
      (Repeat (Rewrite ''xfoldr_Nil'')) Or
      (Repeat (Rewrite ''xfoldr_Cons'')) Or
      (Repeat (Rewrite ''ins_Nil'')) Or
      (Repeat (Rewrite ''ins_Cons'')) Or
      (Repeat (Rewrite ''sort_deff'')) Or
      (Repeat (Rewrite ''o_id'')) Or
      (Repeat (Rewrite ''o_assoc'')) Or
      (Repeat (Rewrite ''o_apply'')) Or
      (Repeat (Rewrite ''id_apply'')) Or
      (Repeat (Calculate ''le'')) Or
      (Repeat (Rewrite ''If_def'')) Or
      (Repeat (Rewrite ''if_True'')) Or
      (Repeat (Rewrite ''if_False'')))
    ) uns)"

method met_Prog_sort_ins_steps : "Programming/SORT/insertion_steps" =
  \<open>{rew_ord="tless_true",rls' = Atools_erls, calc = [], prog_rls = Rule_Set.empty, where_rls = Rule_Set.empty,
    errpats = [], rew_rls = norm_Rational}\<close>
  Program: sort_program2.simps
  Given: "unsorted u_u"
  Find: "sorted s_s"

subsection \<open>CAS-commands\<close>
ML \<open>
(* for starting a new example, e.g. "Sort {|| 1, 3, 2 ||}" after <NEW> on WorkSheet;
   combine this input with dataformat of pbt (without "#Given", etc):
*)
fun argl2dtss [t] =
    [(@{term "unsorted"}, [t]),
     (@{term "sorted"},   [@{term "DUMMY::int xlist"}])
     ]
  | argl2dtss _ = raise ERROR "InsSort.thy: wrong argument for argl2dtss"
\<close>
(* combine input with other data required for formal specification *)
cas Sort = \<open>argl2dtss\<close>
  Theory_Ref: InsSort
  Problem_Ref: "insertion/SORT/Programming"
ML \<open>
\<close> ML \<open>
\<close>
end
