(* Title:  "Minisubpbl/150a-add-given-Maximum.sml"
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.

ATTENTION: the file creates buffer overflow if copied in one piece !

Note: This test --- steps into me --- more than once, to a somewhat extreme extent;
  in order not to get lost while working in Test_Some etc, 
  re-introduce  ML (*--- step into XXXXX ---*) and Co.
  and use Sidekick for orientation.
  Nesting is indicated by  /---   //--   ///-  at the left margin of the comments.
*)

open Test_Code
open Pos
open Ctree
open Tactic
open Specify
open I_Model

val (_(*example text*),
  (model as ("Constants [r = (7::real)]" :: "Maximum A" :: "AdditionalValues [u, v]" :: 
     "Extremum (A = 2 * u * v - u \<up> 2)" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [(u::real) / 2 = r * sin \<alpha>, 2 / v = r * cos \<alpha>]" :: 
     "FunctionVariable a" :: "FunctionVariable b" :: "FunctionVariable \<alpha>" :: 
     "Domain {0 <..< r}" :: "Domain {0 <..< r}" :: "Domain {0 <..< \<pi> / 2}" ::
     "ErrorBound (\<epsilon> = (0::real))" :: []), 
   refs as ("Diff_App", 
     ["univariate_calculus", "Optimisation"],
     ["Optimisation", "by_univariate_calculus"])))
  = Store.get (Know_Store.get_expls @{theory}) ["Diff_App-No.123a"] ["Diff_App-No.123a"];

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(model, refs)]; val Model_Problem = nxt;
val c = [];

(*+*)val PblObj {ctxt, ...} = get_obj I pt [];
(*+*)Proof_Context.theory_of ctxt (*= {Pure, .., Diff_App}*);
(*val    Free ("r", TFree ("'a", []))       = Syntax.read_term ctxt "r" ..ERROR until cs.b7a2ad3b3d45*)
(*+*)val Free ("r", Type ("Real.real", [])) = Syntax.read_term ctxt "r"

val return_me_Model_Problem = 
           me nxt p c pt; val Add_Given "Constants [r = 7]" = #4 return_me_Model_Problem;
(*/------------------- step into me Model_Problem ------------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, (p:Pos.pos'), (_:Test_Code.NEW), (pt:Ctree.ctree)) = (nxt, p, c, pt);
    val (pt, p) = 
      (*ERROR Specify.item_to_add: types or dsc DO NOT MATCH BETWEEN fmz --- pbt ... see 100-init-rootpbl.sml*)
	    case Step.by_tactic tac (pt,p) of
		    ("ok", (_, _, ptp)) => ptp;

(*val ("ok", (ts as (_, _, _) :: _, _, _)) = (*case*)*)
val return_do_next = (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
val ts = return_do_next |> #2 |> #1 |> hd   (* keep for continuing me Model_Problem *)
val continue_Model_Problem = (ts, (pt, p))  (* keep for continuing me Model_Problem *);
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val (((ip as (_,p_)):pos'), ((ptp as (pt,p), tacis):Calc.state_pre)) =
  (p, ((pt, e_pos'),[]));
    val pIopt = get_pblID (pt,ip);
    (*if*) ip = ([],Res); (* = false*)
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);

    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.specify_do_next (pt, input_pos);
(*///----------------- step into specify_do_next -------------------------------------------\\*)
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);

(*  val (_, (p_', tac)) =*)
val return_find_next_step = (*keep for continuing specify_do_next*)
   Specify.find_next_step ptp;
(*////---------------- step into find_next_step --------------------------------------------\\*)
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*then*);

   Specify.for_problem ctxt oris (o_refs, refs) (pbl, met);
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met))
  = (ctxt, oris, (o_refs, refs), (pbl, met));
    val cdI = if dI = ThyC.id_empty then dI' else dI;
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI
    val (preok, _) = Pre_Conds.check ctxt where_rls where_ pbl 0;
    (*if*) dI' = ThyC.id_empty andalso dI = ThyC.id_empty (*else*);
      (*if*) pI' = Problem.id_empty andalso pI = Problem.id_empty (*else*);
      (*case*) find_first (I_Model.is_error o #5) pbl (*of*);

        (*case*)
   Specify.item_to_add (ThyC.get_theory ctxt
            (if dI = ThyC.id_empty then dI' else dI)) oris pbt pbl (*of*);
"~~~~~ fun item_to_add , args:"; val (thy, oris, _, itms)
  = ((ThyC.get_theory ctxt (if dI = ThyC.id_empty then dI' else dI)), oris, pbt, pbl);
      fun testr_vt v ori = member op= (#2 (ori : O_Model.single)) v andalso (#3 ori) <> "#undef"
      fun testi_vt v itm = member op= (#2 (itm : I_Model.single)) v
      fun test_id ids r = member op= ids (#1 (r : O_Model.single))
      fun test_subset itm (_, _, _, d, ts) = 
        (I_Model.descriptor (#5 (itm: I_Model.single))) = d andalso subset op = (I_Model.o_model_values (#5 itm), ts)
      fun false_and_not_Sup (_, _, false, _, I_Model.Sup _) = false
        | false_and_not_Sup (_, _, false, _, _) = true
        | false_and_not_Sup _ = false
      val v = if itms = [] then 1 else Pre_Conds.max_variant itms
      val vors = if v = 0 then oris else filter (testr_vt v) oris
      val vits =
        if v = 0
        then itms                                 (* because of dsc without dat *)
  	    else filter (testi_vt v) itms;                             (* itms..vat *)
      val icl = filter false_and_not_Sup vits;                    (* incomplete *)
      (*if*) icl = [] (*else*);
val SOME ori =
        (*case*) find_first (test_subset (hd icl)) vors (*of*);
(*\\\\---------------- step into find_next_step --------------------------------------------//*)
(*|||----------------- continuing specify_do_next --------------------------------------------*)
val (_, (p_', tac)) = return_find_next_step (*kept for continuing specify_do_next*)

    val ist_ctxt =  Ctree.get_loc pt (p, p_)
(*+*)val Add_Given "Constants [r = 7]" = tac
val _ =
    (*case*) tac (*of*);

Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Add_Given ct), ptp) =
  (tac, (pt, (p, p_')));

   Specify.by_Add_ "#Given" ct ptp;
"~~~~~ fun by_Add_ , args:"; val (m_field, ct ,(pt, pos as (_, p_))) =
  ("#Given", ct, ptp);
    val (met, oris, (_, pI', mI'), pbl, (_, pI, mI), ctxt) = SpecificationC.get_data (pt, pos)
    val (i_model, m_patt) =
       if p_ = Pos.Met then
         (met,
           (if mI = MethodC.id_empty then mI' else mI) |> MethodC.from_store ctxt |> #model)
       else
         (pbl,
           (if pI = Problem.id_empty then pI' else pI) |> Problem.from_store ctxt |> #model);
      (*case*)
   I_Model.check_single ctxt m_field oris i_model m_patt ct (*of*);
"~~~~~ fun check_single , args:"; val (ctxt, m_field, o_model, i_model, m_patt, (str(*, pos*))) =
  (ctxt, m_field, oris, i_model, m_patt, ct);
(*new*) val (t as (descriptor $ _)) = Syntax.read_term ctxt str

(*+*)val "Constants [r = 7]" = UnparseC.term @{context} t;

(*new*)val SOME m_field' =
(*new*)  (*case*) Model_Pattern.get_field descriptor m_patt (*of*);
(*new*)   (*if*) m_field <> m_field' (*else*);

(*+*)val "#Given" = m_field; val "#Given" = m_field'

(*new*)val (msg, _, _) =
(*new*)  (*case*) O_Model.contains ctxt m_field o_model t (*of*);

(*+*)val (_, _, _, _, vals) = hd o_model;
(*+*)val "Constants [r = 7]" = UnparseC.term @{context} (@{term Constants} $ (hd vals));
(*+*) if "[\n(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), " ^ 
(*+*)     "\n(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), " ^ 
(*+*)     "\n(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), " ^ 
(*+*)     "\n(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), " ^ 
(*+*)     "\n(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"]), " ^ 
(*+*)     "\n(6, [\"3\"], #Relate, SideConditions, [\"[u / 2 = r * sin \<alpha>]\", \"[2 / v = r * cos \<alpha>]\"]), " ^ 
(*+*)     "\n(7, [\"1\"], #undef, FunctionVariable, [\"a\"]), " ^ 
(*+*)     "\n(8, [\"2\"], #undef, FunctionVariable, [\"b\"]), \n(9, [\"3\"], #undef, FunctionVariable, [\"\<alpha>\"]), " ^ 
(*+*)     "\n(10, [\"1\", \"2\"], #undef, Input_Descript.Domain, [\"{0<..<r}\"]), " ^ 
(*+*)     "\n(11, [\"3\"], #undef, Input_Descript.Domain, [\"{0<..<\<pi> / 2}\"]), " ^ 
(*+*)     "\n(12, [\"1\", \"2\", \"3\"], #undef, ErrorBound, [\"\<epsilon> = 0\"])]"
(*+*) = O_Model.to_string @{context} o_model then () else error "o_model CHANGED";
(*\\------------------ step into into do_next ----------------------------------------------//*)

(*|------------------- continue with me Model_Problem ----------------------------------------*)
val (ts, (pt, p)) = continue_Model_Problem;
val ("ok", (ts as (_, _, _) :: _, _, _)) = return_do_next

val tacis as (_::_) =
        (*case*) ts (*of*);
          val (tac, _, _) = last_elem tacis

val return = (p, [] : NEW,
           TESTg_form ctxt (pt, p), tac, Celem.Sundef, pt);
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt, p));
    val (form, _, _) = ME_Misc.pt_extract ctxt ptp
val Ctree.ModSpec (_, p_, _, gfr, where_, _) =
    (*case*) form (*of*);

(*+*)val Pos.Pbl = p_;
    Test_Out.PpcKF (  (Test_Out.Problem [],
 			P_Model.from (Proof_Context.theory_of ctxt) gfr where_));

(*//------------------ inserted hidden code ------------------------------------------------\\*)
fun item_from_feedback thy (I_Model.Cor ((d, ts), _)) = P_Model.Correct (UnparseC.term_in_thy thy (Input_Descript.join (d, ts)))
  | item_from_feedback _ (I_Model.Syn c) = P_Model.SyntaxE c
  | item_from_feedback _ (I_Model.Typ c) = P_Model.TypeE c
  | item_from_feedback thy (I_Model.Inc ((d, ts), _)) = P_Model.Incompl (UnparseC.term_in_thy thy  (Input_Descript.join (d, ts)))
  | item_from_feedback thy (I_Model.Sup (d, ts)) = P_Model.Superfl (UnparseC.term_in_thy thy  (Input_Descript.join (d, ts)))
  | item_from_feedback thy (I_Model.Mis (d, pid)) = P_Model.Missing (UnparseC.term_in_thy thy d ^ " " ^ UnparseC.term_in_thy thy  pid)
  | item_from_feedback _ _ = raise ERROR "item_from_feedback: uncovered definition"
fun add_sel_ppc (_: theory) sel {Given = gi, Where = wh, Find = fi, With = wi, Relate = re} x =
  case sel of
    "#Given" => {Given = gi @ [x], Where = wh, Find = fi, With = wi,Relate = re}
  | "#Where" => {Given = gi, Where = wh @ [x], Find = fi, With = wi, Relate = re}
  | "#Find"  => {Given = gi, Where = wh, Find = fi @ [x], With = wi, Relate = re}
  | "#Relate"=> {Given = gi, Where = wh, Find = fi, With = wi, Relate = re @ [x]}
  | "#undef" => {Given = gi @ [x], Where = wh, Find = fi, With = wi, Relate = re} (*ori2itmSup*)
  | _  => raise ERROR ("add_sel_ppc tried to select by \"" ^ sel ^ "\"")
fun add_where {Given = gi, Where = _, Find = fi, With = wi, Relate = re} wh =
  {Given = gi, Where = wh, Find= fi ,With = wi, Relate = re}
fun boolterm2item ctxt (true, term) = P_Model.Correct (UnparseC.term ctxt term)
  | boolterm2item ctxt(false, term) = P_Model.False (UnparseC.term ctxt term);
(*\\------------------ inserted hidden code ------------------------------------------------//*)
   P_Model.from (Proof_Context.theory_of ctxt) gfr where_;
"~~~~~ fun from , args:"; val (thy, itms, where_) = ((Proof_Context.theory_of ctxt), gfr, where_);
    fun coll model [] = model
      | coll model ((_, _, _, field, itm_) :: itms) =
        coll (add_sel_ppc thy field model (item_from_feedback thy itm_)) itms;

 val gfr = coll P_Model.empty itms;
"~~~~~ fun coll , args:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: itms))
  = (P_Model.empty, itms);

(*+*)val 4 = length itms;
(*+*)val itm = nth 1 itms;

           coll P_Model.empty [itm];
"~~~~~ fun coll , iterate:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: []))
  = (P_Model.empty, [itm]);

          (add_sel_ppc thy field model (item_from_feedback thy itm_));
"~~~~~ fun add_sel_ppc , args:"; val ((_: theory), sel, {Given = gi, Where = wh, Find = fi, With = wi, Relate = re}, x )
  = (thy, field, model, (item_from_feedback thy itm_));

   P_Model.item_from_feedback thy itm_;
"~~~~~ fun item_from_feedback , args:"; val (thy, (I_Model.Inc ((d, ts), _))) = (thy, itm_);
  P_Model.Incompl (UnparseC.term_in_thy thy (Input_Descript.join (d, ts)));
(*\------------------- step into into me Model_Problem -------------------------------------//*)
val (p, _, f, nxt, _, pt) = return_me_Model_Problem
(*after -------------- step into intoreturn_me_Add_Relation_SideConditions------------------//* )
val (p, _, f, nxt, _, pt) = return_me_Add_Relation_SideConditions
( **)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Maximum A" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "AdditionalValues [u]" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "AdditionalValues [v]" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "Extremum (A = 2 * u * v - u \<up> 2)" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" = nxt;
val return_me_Add_Relation_SideConditions
                     = me nxt p c pt;

(*/------------------- step into me Add_Relation_SideConditions ----------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
      val (pt, p) = 
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp;
    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, Pos.e_pos'), [])) (*of*);
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);
      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);

    val (_, (p_', tac)) =
   Specify.find_next_step ptp (* ..Refine_Problem ["univariate_calculus",?*);
"~~~~~ fun find_next_step , args:"; val (pt, pos as (_, p_)) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*then*);

           for_problem ctxt oris (o_refs, refs) (pbl, met);
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met)) =
  (ctxt, oris, (o_refs, refs), (pbl, met));
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI

(*+*)val [Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $
  Free ("fixes", _)] = where_
    val (preok, _) = Pre_Conds.check_TEST ctxt where_rls (Pre_Conds.unchecked_OLD_to_TEST where_) [(*works by chance*)]
(*\------------------- step into me Add_Relation_SideConditions ----------------------------//*)
val (p, _, f, nxt, _, pt) = return_me_Add_Relation_SideConditions
                                      val Specify_Theory "Diff_App" = nxt;

val return_me_Specify_Theory
                     = me nxt p c pt; val Specify_Problem ["univariate_calculus", "Optimisation"] = #4 return_me_Specify_Theory;
(*/------------------- step into me Specify_Theory -----------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
      val (pt, p) = 
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp

val ("ok", (ts as (_, _, _) :: _, _, _)) =
    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, Pos.e_pos'), [])) (*of*);
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_);
    (*case*) tac (*of*);

Step_Specify.by_tactic_input  tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Problem pI), (pt, pos as (p, _)))
  = (tac, (pt, (p, p_')));
      val (oris, dI, dI', pI', probl, ctxt) = case get_obj I pt p of
        PblObj {origin = (oris, (dI,_,_),_), spec = (dI',pI',_), probl, ctxt, ...} =>
          (oris, dI, dI', pI', probl, ctxt)
	    val thy = ThyC.get_theory ctxt (if dI' = ThyC.id_empty then dI else dI');
      val {model, where_, where_rls,...} = Problem.from_store (Ctree.get_ctxt pt pos) pI
(*\\------------------ step into do_next ---------------------------------------------------//*)
(*\------------------- step into me Specify_Theory -----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Specify_Theory;

val return_me_Specify_Problem (* keep for continuing me *)
                     = me nxt p c pt; val Specify_Method ["Optimisation", "by_univariate_calculus"] = #4 return_me_Specify_Problem;
(*/------------------- step into me Specify_Problem ----------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p

(** )  val ("ok", (_, _, ptp as (pt, p))) =( **)
(**)    val return_by_tactic =(**) (*case*)
      Step.by_tactic tac (pt, p) (*of*);
(*//------------------ step into by_tactic -------------------------------------------------\\*)
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt, p));

    (*case*)
      Step.check tac (pt, p) (*of*);
"~~~~~ fun check , args:"; val (tac, (ctree, pos)) = (tac, (pt, p));
  (*if*) Tactic.for_specify tac (*then*);

Specify_Step.check tac (ctree, pos);
"~~~~~ fun check , args:"; val ((Tactic.Specify_Problem pID), (pt, pos as (p, _)))
  = (tac, (ctree, pos));
		    val (oris, dI, pI, dI', pI', itms) = case Ctree.get_obj I pt p of
		      Ctree.PblObj {origin = (oris, (dI, pI, _), _), spec = (dI', pI', _), probl = itms, ...}
		        => (oris, dI, pI, dI', pI', itms)
	      val thy = ThyC.get_theory ctxt (if dI' = ThyC.id_empty then dI else dI');
(*\\------------------ step into by_tactic -------------------------------------------------//*)
val ("ok", (_, _, ptp as (pt, p))) = return_by_tactic (* kept for continuing me *);

      (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, Pos.e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val _ =
    (*case*) tac (*of*);

Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Method id), (pt, pos))
  = (tac, (pt, (p, p_')));

      val (o_model, ctxt, i_model) =
Specify_Step.complete_for id (pt, pos);
"~~~~~ fun complete_for , args:"; val (mID, (ctree, pos)) = (id, (pt, pos));
    val {origin = (o_model, o_refs, _), spec = refs, probl = i_prob, ctxt,
       ...} = Calc.specify_data (ctree, pos);
    val ctxt = Ctree.get_ctxt ctree pos
    val (dI, _, _) = References.select_input o_refs refs;
    val {model = m_patt, where_, where_rls, ...} = MethodC.from_store ctxt mID
    val {origin = (root_model, _, _), ...} = Calc.specify_data (ctree, ([], Pos.Und))
    val (o_model', ctxt') = O_Model.complete_for m_patt root_model (o_model, ctxt)
    val thy = ThyC.get_theory ctxt dI
    val (_, (i_model, _)) = M_Match.match_itms_oris ctxt i_prob (m_patt, where_, where_rls) o_model';
(*\------------------- step into me Specify_Problem ----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Specify_Problem

val return_me_Add_Given_FunctionVariable
                     = me nxt p c pt; val Add_Given "FunctionVariable a" = #4 return_me_Add_Given_FunctionVariable;
(*/------------------- step into me Specify_Method -----------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
      val (pt, p) = 
  	    (*Step.by_tactic is here for testing by me; do_next would suffice in me*)
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp;

         (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, Pos.e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);

    val (_, (p_', tac)) =
   Specify.find_next_step ptp;
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*else*);

   Specify.for_method ctxt oris (o_refs, refs) (pbl, met);
"~~~~~ fun for_method , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met))
  = (ctxt, oris, (o_refs, refs), (pbl, met));
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = mpc, where_rls, where_, ...} = MethodC.from_store ctxt cmI;    (*..MethodC ?*)
    val (preok, _) = Pre_Conds.check ctxt where_rls where_ pbl 0;
val NONE =
    (*case*) find_first (I_Model.is_error o #5) met (*of*);

      (*case*)
   Specify.item_to_add (ThyC.get_theory ctxt 
     (if dI = ThyC.id_empty then dI' else dI)) oris mpc met (*of*);
"~~~~~ fun item_to_add , args:"; val (thy, oris, _, itms)
  = ((ThyC.get_theory ctxt (if dI = ThyC.id_empty then dI' else dI)), oris, mpc, met);
(*\------------------- step into me Specify_Method -----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Add_Given_FunctionVariable

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Input_Descript.Domain {0<..<r}" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "ErrorBound (\<epsilon> = 0)" = nxt;
(*
  nxt would be Tactic.Apply_Method, which tries to determine a next step in the ***Program***,
  but the ***Program*** is not yet perfectly implemented.
val (p,_,f,nxt,_,pt) = me nxt p c pt;
*)
