(* Title:  "Specify/pre-conditions.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- build Pre_Conds.check_TEST --------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

"----------- build Pre_Conds.check_TEST --------------------------------------------------------";
"----------- build Pre_Conds.check_TEST --------------------------------------------------------";
"----------- build Pre_Conds.check_TEST --------------------------------------------------------";
(*see Outer_Syntax:    val (model, where_) = Model_Pattern.parse_pos_empty ctxt model_input*)
open I_Model
open Pre_Conds;
(*//------------------ test data setup -----------------------------------------------------\\*)
val thy = @{theory Calculation}

            val state =
              case the_data thy of
                  CTbasic_TEST.EmptyPtree => Preliminary.init_ctree thy example_id
                | _(*state (*FOR TEST*)*) => (**)the_data thy(**)
                  (*let*)
                    val {origin = (o_model, o_ref, _), spec = spec_ref, probl, meth, ctxt, ...} =
                      CTbasic_TEST.get_obj I state [(*Pos will become variable*)] |> CTbasic_TEST.rep_specify_data
;
probl: Model_Def.i_model_TEST 
(*[(1, [1, 2, 3], false, "#Given", (Inp_TEST (Const ("Input_Descript.Constants", "bool list \<Rightarrow> nam"), "[__=__, __=__]"), {})),
   (2, [1, 2, 3], false, "#Find", (Inp_TEST (Const ("Input_Descript.Maximum", "real \<Rightarrow> toreal"), "__"), {})),
   (3, [1, 2, 3], false, "#Find", (Inp_TEST (Const ("Input_Descript.AdditionalValues", "real list \<Rightarrow> toreall"), "[__, __]"), {})),
   (4, [1, 2, 3], false, "#Relate", (Inp_TEST (Const ("Input_Descript.Extremum", "bool \<Rightarrow> toreal"), "__"), {})),
   (5, [1, 2], false, "#Relate", (Inp_TEST (Const ("Input_Descript.SideConditions", "bool list \<Rightarrow> una"), "[__=__, __=__]"), {}))]*)
;
val probl_POS = (*from above, #1 and #2 replaced by complete items*)
  (1, [1,2,3], true, "#Given",
    (Cor_TEST ((@{term "Constants"}, [@{term "[r = (7::real)]"(*should be "r = (7::real)"*)}]),
      (@{term "fixes::real"}, [@{term "r::real"}])), Position.none )) ::
  nth 2 probl :: nth 3 probl :: nth 4 probl ::
  (5, [1,2], true, "#Relate",
    (Cor_TEST ((@{term "SideConditions"}, [@{term "[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]"}]),
      (@{term "sideconds::bool list"}, [TermC.empty])), Position.none ))
  :: [];
val POS_to_OLD =
(fn (a, b, c, d, (Cor_TEST args, _(*pos*))) => (a, b, c, d, Cor args)
  | (a, b, c, d, (Inp_TEST (dsc, str), _)) =>
      (a, b, c, d, Syn (UnparseC.term @{context} dsc ^ " " ^ str))
  | _ => raise ERROR "POS_to_OLD does not implement that feedback")
  : I_Model.single_TEST -> I_Model.single
;
val probl_OLD = map POS_to_OLD probl;

val {model = model_patt, where_rls, where_ = where_OLD, ...} = (*from_store without Position.T-vv*)
  Problem.from_store ctxt (References.explode_id "univariate_calculus/Optimisation")
;
(model_patt |> Model_Pattern.to_string ctxt) =
 "[\"(#Given, (Constants, fixes))\", " ^
  "\"(#Find, (Maximum, maxx))\", " ^
  "\"(#Find, (AdditionalValues, vals))\", " ^
  "\"(#Relate, (Extremum, extr))\", " ^
  "\"(#Relate, (SideConditions, sideconds))\"]";
val "[0 < fixes]" = (where_OLD |> UnparseC.terms @{context})

(*prepare check input with Position.T----------------------------------------------------------^^-*)
val where_POS = [(@{term "0 < (r::real)"}, Position.none)];
(*\\------------------ test data setup -----------------------------------------------------//*)

(*//------------------ test on old code (partially with Position.T) ------------------------\\*)
           check ctxt where_rls where_OLD probl_OLD "DEL: variants";
"~~~~~ fun check ,  args:"; val (ctxt, where_rls, pres, pbl) =
  (ctxt, where_rls, where_OLD, probl_OLD);
      (*the values wanted, not yet achieved..*)
      val env = Pre_Conds.environment pbl: Env.T
        (* [(fixes, r)] *)
(*/----- already in test/../preconditions ---------------------------------------------*)
      val pres' = map (TermC.subst_atomic_all env) pres: (bool * term) list
        (* [(true, 0 < x)] .. true: all substituted*)
      val evals = map (eval ctxt where_rls) pres': (bool * term) list
        (* [(true, 0 < x)] .. true: evaluated to true*)
val return_check =
        (foldl and_ (true, map fst evals), evals): bool * (bool * term) list;

           eval ctxt where_rls (hd pres');
"~~~~~ fun eval , args:"; val (ctxt, where_rls, (bool, where_)) = (ctxt, where_rls, hd pres');
    (*if*) Rewrite.eval_true ctxt [where_] where_rls (*then*);

(* final test ... ----------------------------------------------------------------------------*)
val (false, (*230311: should become true ! TODO-----vvvvvvv substituted with \<open>r\<close> *)
    [(false, (*Pre_Conds.eval wrong, because of: ...                             *)
      Const ("Orderings.ord_class.less", _) $
        Const ("Groups.zero_class.zero", _) $ Free ("fixes", _))]) = return_check;
(*\\------------------ test on old code (partially with Position.T) ------------------------//*)

(*//------------------ build new code (with Position.T) ------------------------------------\\*)
 Pre_Conds.check_TEST ctxt where_rls where_POS;
"~~~~~ fun check_TEST ,  args:"; val (ctxt, where_rls, preconds) =
  (ctxt, where_rls, where_POS);

(*+*)val [(Const ("Orderings.ord_class.less", _) $
  Const ("Groups.zero_class.zero", _) $ Free ("r", _), _)] = where_POS

      val full_subst =
        map (fn (t, pos) => (subst_atomic env_eval t, pos)) where_POS
      val evals =
        map (fn (term, pos) => (Rewrite.eval_true ctxt [term] where_rls, (term, pos))) preconds
(*+*)val [(true, (Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $ 
  Free ("r", _), _))] = evals

(** )declare [[rewrite_trace = true]](**)
val [(term, _)] = full_subst (*ERROR "true" with where_POS*);
Rewrite.eval_true @{context} [term] where_rls (*true by code ERROR WN230329*)
(**)declare [[rewrite_trace = false]]( **)

val return_check_TEST =
           (foldl and_ (true, map fst evals), (map fst evals) ~~ preconds)
(* final test ... ----------------------------------------------------------------------------*)
val (true, [(true, (Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $ 
  Free ("r", _), _))]) = return_check_TEST
(*\\------------------ build new code (with Position.T) ------------------------------------//*)
